searchNodes=[{"doc":"Generates the standard rules config.mix simple_markdown.rules.new [--format] [-o PATH] A --format option can be used to indicate that the output be formatted according to the auto formatter. A -o option can be used to specify the file to be written. Defaults to &quot;config/simple_markdown_rules.exs&quot; if a path is not provided. The rules config should be imported into the app's config.exsimport_config &quot;simple_markdown_rules.exs&quot; The rule config may be changed to suit your needs, if new rules are added or you wish the rendering behaviour of current rules to be changed this can be done by defining new rendering implementations for those rules.","ref":"Mix.Tasks.SimpleMarkdown.Rules.New.html","title":"Mix.Tasks.SimpleMarkdown.Rules.New","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.SimpleMarkdown.Rules.New.html#run/1","title":"Mix.Tasks.SimpleMarkdown.Rules.New.run/1","type":"function"},{"doc":"Converts markdown into the specified rendered output. While this step is completely optional, if you need to configure any rules the first thing to do is usually to generate the base rule config.$ mix simple_markdown.rules.new And then importing the config in your config.exs:import_config &quot;simple_markdown_rules.exs&quot; This config can be customized as you see fit. With new rules added, and other rules removed or modified. Depending on the changes made this may require some additional steps for things to work the way you want. e.g. If you add or change the way a rule type fundamentally works, you'll need to add or override the required rendering step for that type. Details for this can be found in renderer protocols. Example#config/simple_markdown_rules.exs #add the following rule to our ruleset lol: %{ match: ~r/\\Alol/, rules: [] } #lib/lol_renderer.ex #add a renderer for the HTML renderer for our &quot;lol&quot; rule defimpl SimpleMarkdown.Renderer.HTML, for: SimpleMarkdown.Attribute.Lol do def render(_), do: &quot;&lt;img src=\\&quot;lolcat.jpg\\&quot;&gt;&quot; end #usage: SimpleMarkdown.convert(&quot;#lol&quot;) #=&gt; &quot;&lt;h1&gt;&lt;img src=\\&quot;lolcat.jpg\\&quot;&gt;&lt;/h1&gt;&quot; Additionally new renderers can be created. How these new renderers should be implemented is left up to you depending on how you'll provide input. If you use the standard convert/2 then the input will be parsed, then the AST will be converted to these structs, and then that will be passed to your renderer. Alternatively you may call SimpleMarkdown.Parser.parse/1 directly and then manipulate that AST how you see fit, and pass that to your renderer.","ref":"SimpleMarkdown.html","title":"SimpleMarkdown","type":"module"},{"doc":"Convert the AST into structs to allow for the rendering protocols to be applied to individual attributes.","ref":"SimpleMarkdown.html#ast_to_structs/1","title":"SimpleMarkdown.ast_to_structs/1","type":"function"},{"doc":"Create a child module relative to parent.","ref":"SimpleMarkdown.html#child_module!/2","title":"SimpleMarkdown.child_module!/2","type":"function"},{"doc":"Convert the text input into the rendered output. The default parser used is the one provided in the rules config, and the default renderer is the HTML renderer.","ref":"SimpleMarkdown.html#convert/2","title":"SimpleMarkdown.convert/2","type":"function"},{"doc":"Format a string to follow the module naming convention.","ref":"SimpleMarkdown.html#format_as_module/1","title":"SimpleMarkdown.format_as_module/1","type":"function"},{"doc":"","ref":"SimpleMarkdown.html#t:attribute/0","title":"SimpleMarkdown.attribute/0","type":"type"},{"doc":"A lazily evaluated renderer protocol for HTML. Any customisation should be done to SimpleMarkdown.Renderer.HTML.","ref":"SimpleMarkdown.LazyRenderer.HTML.html","title":"SimpleMarkdown.LazyRenderer.HTML","type":"protocol"},{"doc":"Render the parsed markdown as HTML.","ref":"SimpleMarkdown.LazyRenderer.HTML.html#render/1","title":"SimpleMarkdown.LazyRenderer.HTML.render/1","type":"function"},{"doc":"","ref":"SimpleMarkdown.LazyRenderer.HTML.html#t:t/0","title":"SimpleMarkdown.LazyRenderer.HTML.t/0","type":"type"},{"doc":"Parse the string with the given markdown ruleset. For understanding of how rulesets work, check the Parsey docs.","ref":"SimpleMarkdown.Parser.html","title":"SimpleMarkdown.Parser","type":"module"},{"doc":"Get the default parsing rules.","ref":"SimpleMarkdown.Parser.html#default_rules/0","title":"SimpleMarkdown.Parser.default_rules/0","type":"function"},{"doc":"Parse the string with the rules found in the config file.","ref":"SimpleMarkdown.Parser.html#parse/1","title":"SimpleMarkdown.Parser.parse/1","type":"function"},{"doc":"Parse the string with the specified ruleset.","ref":"SimpleMarkdown.Parser.html#parse/2","title":"SimpleMarkdown.Parser.parse/2","type":"function"},{"doc":"Get the current parsing rules.","ref":"SimpleMarkdown.Parser.html#rules/0","title":"SimpleMarkdown.Parser.rules/0","type":"function"},{"doc":"A renderer protocol for HTML. Individual rule renderers can be overriden or new ones may be added. Rule types follow the format of structs defined under SimpleMarkdown.Attribute.*. e.g. If there is a rule with the name :header, to provide a rendering implementation for that rule, you would specify for: SimpleMarkdown.Attribute.Header. Rules then consist of a Map with an input field, and an optional option field. See SimpleMarkdown.attribute/0. HTML vs AST The AST format (SimpleMarkdown.Renderer.HTML.Utilities.ast/0) provides a more flexible general purpose way of structuring HTML. While HTML provides a more cumbersome by explicit way of structuring the rendered HTML. When there is no implementation for a certain rule it will fallback to the SimpleMarkdown.Renderer.HTML.AST renderer (if one exists) and will convert that AST to HTML using SimpleMarkdown.Renderer.HTML.Utilities.ast_to_html/2. So you only need to maintain one set of implementations to cover all HTML renderers. Exampledefimpl SimpleMarkdown.Renderer.HTML, for: SimpleMarkdown.Attribute.Header do def render(%{ input: input, option: size }), do: &quot;&lt;h\#{size}&gt;\#{SimpleMarkdown.Renderer.HTML.render(input)}&lt;/h\#{size}&gt;&quot; end","ref":"SimpleMarkdown.Renderer.HTML.html","title":"SimpleMarkdown.Renderer.HTML","type":"protocol"},{"doc":"Render the parsed markdown as HTML.","ref":"SimpleMarkdown.Renderer.HTML.html#render/1","title":"SimpleMarkdown.Renderer.HTML.render/1","type":"function"},{"doc":"","ref":"SimpleMarkdown.Renderer.HTML.html#t:t/0","title":"SimpleMarkdown.Renderer.HTML.t/0","type":"type"},{"doc":"A renderer protocol for HTML AST. Individual rule renderers can be overriden or new ones may be added. Rule types follow the format of structs defined under SimpleMarkdown.Attribute.*. e.g. If there is a rule with the name :header, to provide a rendering implementation for that rule, you would specify for: SimpleMarkdown.Attribute.Header. Rules then consist of a Map with an input field, and an optional option field. See SimpleMarkdown.attribute/0. HTML vs AST The AST format (SimpleMarkdown.Renderer.HTML.Utilities.ast/0) provides a more flexible general purpose way of structuring HTML. While HTML provides a more cumbersome by explicit way of structuring the rendered HTML. When there is no implementation for a certain rule it will fallback to the SimpleMarkdown.Renderer.HTML renderer (if one exists) and will convert that HTML to AST using SimpleMarkdown.Renderer.HTML.Utilities.html_to_ast/2. So you only need to maintain one set of implementations to cover all HTML renderers. Exampledefimpl SimpleMarkdown.Renderer.HTML.AST, for: SimpleMarkdown.Attribute.Header do def render(%{ input: input, option: size }), do: { &quot;h\#{size}&quot;, [], SimpleMarkdown.Renderer.HTML.AST.render(input) } end","ref":"SimpleMarkdown.Renderer.HTML.AST.html","title":"SimpleMarkdown.Renderer.HTML.AST","type":"protocol"},{"doc":"Render the parsed markdown as HTML AST.","ref":"SimpleMarkdown.Renderer.HTML.AST.html#render/1","title":"SimpleMarkdown.Renderer.HTML.AST.render/1","type":"function"},{"doc":"","ref":"SimpleMarkdown.Renderer.HTML.AST.html#t:t/0","title":"SimpleMarkdown.Renderer.HTML.AST.t/0","type":"type"},{"doc":"Convenient functions for working with HTML.","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html","title":"SimpleMarkdown.Renderer.HTML.Utilities","type":"module"},{"doc":"Convert the HTML AST to HTML. The conversion behaviour can be modified by setting the opts parameter with any of the following::format - To control the HTML format. This takes one of the valid formats/0. By default this is set to generate HTML5 code ({ :html, { 5, 0 } }).:void_elements - To customise which elements are void elements (do not contain content). This takes a tag_list/0. By default this is set to the list of tags returned by void_elements/0.:raw_text_elements - To customise which elements are raw text elements (do not encode their content nor contain nested nodes). This takes a tag_list/0. By default this is set to the list of tags returned by raw_text_elements/0.:include_chardata - To control whether nodes that match :chardata should be included in the HTML or not. By default this is set to false.:chardata - To customise which elements are considered to be character data (special cases that do not encode their content nor contain nested nodes). This takes a chardata_list/0. By default this is set to the list of opening/closing tags returned by chardata/0. Exampleiex&gt; SimpleMarkdown.Renderer.HTML.Utilities.ast_to_html({ :p, [], &quot;hello&quot; }) |&gt; IO.chardata_to_string &quot;&lt;p&gt;hello&lt;/p&gt;&quot; iex&gt; SimpleMarkdown.Renderer.HTML.Utilities.ast_to_html({ &quot;!--&quot;, [], &quot;hello&quot; }, include_chardata: true) |&gt; IO.chardata_to_string &quot;&lt;!--hello--&gt;&quot;","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#ast_to_html/2","title":"SimpleMarkdown.Renderer.HTML.Utilities.ast_to_html/2","type":"function"},{"doc":"A list of any special nodes that will be treated as raw character data. Currently this includes comments, character data, DTD (document type definitions), PI (processing instructons). Examples of currently supported nodes and how they're represented in the AST:{ &quot;!--&quot;, [], &quot; comment &quot; } #&lt;!-- comment --&gt; { &quot;![CDATA[&quot;, [], &quot;foo&quot; } #&lt;![CDATA[foo]]&gt; { &quot;!DOCTYPE&quot;, [], &quot; html&quot; } #&lt;!DOCTYPE html&gt; { &quot;?&quot;, [], &quot;xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; &quot; } #&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; ?&gt;","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#chardata/0","title":"SimpleMarkdown.Renderer.HTML.Utilities.chardata/0","type":"function"},{"doc":"Convert the HTML to HTML AST. The parsing behaviour can be modified by setting the opts parameter with any of the following::void_elements - To customise which elements are void elements (do not contain content). This takes a tag_list/0. By default this is set to the list of tags returned by void_elements/0.:raw_text_elements - To customise which elements are raw text elements (do not encode their content nor contain nested nodes). This takes a tag_list/0. By default this is set to the list of tags returned by raw_text_elements/0.:include_chardata - To control whether nodes that match :chardata should be included in the AST or not. By default this is set to false.:chardata - To customise which elements are considered to be character data (special cases that do not encode their content nor contain nested nodes). This takes a chardata_list/0. By default this is set to the list of opening/closing tags returned by chardata/0. Exampleiex&gt; SimpleMarkdown.Renderer.HTML.Utilities.html_to_ast(&quot;&lt;p&gt;hello&lt;/p&gt;&quot;) { &quot;p&quot;, [], &quot;hello&quot; } iex&gt; SimpleMarkdown.Renderer.HTML.Utilities.html_to_ast(&quot;&lt;!--hello--&gt;&quot;, include_chardata: true) { &quot;!--&quot;, [], &quot;hello&quot; }","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#html_to_ast/2","title":"SimpleMarkdown.Renderer.HTML.Utilities.html_to_ast/2","type":"function"},{"doc":"A list of raw text elements.","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#raw_text_elements/0","title":"SimpleMarkdown.Renderer.HTML.Utilities.raw_text_elements/0","type":"function"},{"doc":"A list of void elements.","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#void_elements/0","title":"SimpleMarkdown.Renderer.HTML.Utilities.void_elements/0","type":"function"},{"doc":"","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#t:ast/0","title":"SimpleMarkdown.Renderer.HTML.Utilities.ast/0","type":"type"},{"doc":"","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#t:chardata_list/0","title":"SimpleMarkdown.Renderer.HTML.Utilities.chardata_list/0","type":"type"},{"doc":"","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#t:format/1","title":"SimpleMarkdown.Renderer.HTML.Utilities.format/1","type":"type"},{"doc":"","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#t:formats/0","title":"SimpleMarkdown.Renderer.HTML.Utilities.formats/0","type":"type"},{"doc":"","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#t:tag_list/0","title":"SimpleMarkdown.Renderer.HTML.Utilities.tag_list/0","type":"type"},{"doc":"","ref":"SimpleMarkdown.Renderer.HTML.Utilities.html#t:version/0","title":"SimpleMarkdown.Renderer.HTML.Utilities.version/0","type":"type"}]